!
interface dialog_box create  &
   dialog_box_name = .ACME.multipost.dboxes.acm_multi_ana_sub  &
   location = 646.0, 240.0  &
   height = 603.0  &
   width = 452.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   title = "Full-Vehicle Analysis: Multi Poster Testrig"  &
   iconifiable = no  &
   start_commands = "var set var =$_self.errorFlag int =0",  &
                    "variable set variable_name=$_self.entity_comments string_value=\"\"",  &
                    "",  &
                    "!!! Update the assembly option menu in case new assemblies have been opened.",  &
                    "variable set variable = $_self.updateOption &",  &
                    " int=(eval(gui_upd_assytestrig_omenu($_topgui.cont_assy.o_assembly,\"__ACME_MULTI_POST_TESTRIG\")))",  &
                    "interface option_menu execute option_menu_name=$_topgui.cont_assy.o_assembly",  &
                    "",  &
                    "!!! Create a variable under the dbox to store the assembly so it can ",  &
                    "!!! get passed around to other macros.",  &
                    "if condition=(!db_exists(\"$_self.assembly\"))",  &
                    "   variable set variable=$_self.assembly object_value=(none)",  &
                    "end",  &
                    "",  &
                    "!!! Force option menus in the cont_act_type_multi container",  &
                    "!!! to execute their commands. This assigns variables in the ARIDE",  &
                    "!!! library.",  &
                    "interface container display container_name = cont_act_type_multi"  &
   finish_commands = "variable delete variable_name=(eval(db_children($_self,\"variable\")))"  &
   execution_commands = "!!! Check existing Analysis.",  &
                        "",  &
                        "if condition=((eval(db_exists(eval($f_output_prefix//\"_MultiPost\")))))",  &
                        "   if condition=(alert(\"question\",\"The multipost analysis with given output prefix already exists.  Overwrite it?\",\"Yes\",\"No\",\"\",2)==2)",  &
                        "      var set var =$_self.errorFlag int =1",  &
                        "      return",  &
                        "   end",  &
                        "end",  &
                        "!!! Perform setup operations common to all FOUR_POST_TESTRIG",  &
                        "!!! analyses.",  &
                        "acme multipost setup common assembly=(eval($_topgui.assembly))",  &
                        "",  &
                        "!!! Perform setup operations particular to an analysis.",  &
                        "if condition=(\"$o_nout_basis\" == \"stepcount\")",  &
                        "   variable set variable=$_self.tmpstepcount integer=(eval($out_num))",  &
                        "elseif condition=(\"$o_nout_basis\" == \"stepsize\")",  &
                        "   variable set variable=$_self.tmpstepcount integer=(eval($t_final/$out_num))",  &
                        "elseif condition=(\"$o_nout_basis\" == \"frequency\")",  &
                        "   variable set variable=$_self.tmpstepcount integer=(eval($t_final*$out_num))",  &
                        "end",  &
                        "",  &
                        "acme multipost setup arbitrary_solver_functions  &",  &
                        "   assembly=(eval($_topgui.assembly)) &",  &
                        "   sfn_lf=$f_sfn_lf  &",  &
                        "   sfn_rf=$f_sfn_rf  &",  &
                        "   sfn_lr=$f_sfn_lr  &",  &
                        "   sfn_rr=$f_sfn_rr  &",  &
                        "   sfn_lr2=$f_sfn_lr2  &",  &
                        "   sfn_rr2=$f_sfn_rr2  &",  &
                        "   sfn_units=\"$o_sfn_units\"",  &
                        "",  &
                        "acar toolkit message message=\"Setup of the vehicle assembly is completed.\"",  &
                        "",  &
                        "acme multipost analysis submit &",  &
                        " assembly=(eval($_topgui.assembly)) &",  &
                        " output_prefix=$f_output_prefix &",  &
                        " time_final=(eval($t_final*units_conversion_factor(\"1/s\"))) &",  &
                        " analysis_mode=\"$o_analysis_mode\" &",  &
                        " log_file=$t_logfile &",  &
                        " comment=(eval(acm_multi_ana_sub.entity_comments)) &",  &
                        " load_results=\"yes\" &",  &
                        " number_of_steps=(eval($_self.tmpstepcount)) ",  &
                        "",  &
                        "!!! Restore the activity of sse wheel jprims used in A/Car.",  &
                        "aride toolkit set spindle_lock_rotation_activity_sse &",  &
                        " assembly=(eval($_topgui.assembly)) &",  &
                        " active=no_opinion",  &
                        "",  &
                        "!!! Restore the steering wheel activity in A/Car.",  &
                        "aride toolkit set steering_wheel_lock_rotation_activity &",  &
                        " assembly=(eval($_topgui.assembly)) &",  &
                        " active=no_opinion",  &
                        "",  &
                        "!!! Restore tire activity in A/Car.",  &
                        "aride toolkit set acar_tires_activity &",  &
                        " assembly=(eval($_topgui.assembly)) &",  &
                        " active=no_opinion",  &
                        ""  &
   decorate = yes  &
   resizable = yes  &
   width_minimum = 452.0  &
   height_minimum = 603.0  &
   height_maximum = 603.0  &
   grab_all_input = no
!
interface container create  &
   container_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy  &
   location = 4.0, 4.0  &
   height = 120.0  &
   width = 444.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.l_assembly  &
   location = 4.0, 4.0  &
   height = 25.0  &
   width = 130.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Full-Vehicle Assembly"
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.o_assembly  &
   location = 228.0, 4.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   choices = "Demo_Multi_Post"  &
   current_choice = "Demo_Multi_Post"  &
   values = ".Demo_Multi_Post"  &
   commands = "if condition = (\"$_value\" == \"noneActive\")",  &
              "   variable set variable_name=$_topgui.assembly &",  &
              "    object_value=(none)",  &
              "else",  &
              "   variable set variable_name=$_topgui.assembly &",  &
              "    object_value=$_value",  &
              "   default model model=$_value part=$_value.ground",  &
              "   model display fit_to_view=no",  &
              "   view zoom auto_zoom=no_ground",  &
              "   acar interface update_menus adjust_menu",  &
              "end"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.l_output_prefix  &
   location = 4.0, 29.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Output Prefix"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.f_output_prefix  &
   help_text = "Analysis output name"  &
   location = 228.0, 29.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = literal  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.l_time_final  &
   location = 4.0, 54.0  &
   height = 25.0  &
   width = 150.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "End Time"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.t_final  &
   help_text = "Enter the desired simulation end time."  &
   location = 228.0, 54.0  &
   height = 25.0  &
   width = 105.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = yes  &
   number_of_values = 1  &
   numeric_type = real  &
   upper_check = none  &
   lower_check = gt  &
   lower_limit = 0.0
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.l_end_time_units  &
   location = 335.0, 54.0  &
   height = 25.0  &
   width = 6.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "s"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.l_analysis_mode  &
   location = 4.0, 79.0  &
   height = 25.0  &
   width = 150.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Mode Of Simulation"
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_assy.o_analysis_mode  &
   help_text = "Select the mode of simulation"  &
   location = 228.0, 79.0  &
   height = 25.0  &
   width = 105.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   choices = "interactive", "background", "files_only"  &
   current_choice = "interactive"
!
interface container create  &
   container_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_nout  &
   location = 4.0, 135.0  &
   height = 50.0  &
   width = 444.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_nout.o_nout_basis  &
   location = 4.0, 15.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   choices = "number of steps", "step size", "frequency"  &
   current_choice = "number of steps"  &
   values = "stepcount", "stepsize", "frequency"  &
   commands = "interface field modify field=$_topgui.o_nout_basis &",  &
              " numeric_type = (eval(\"$_value\" == \"stepcount\" ? \"integer\" : \"real\")) "
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_nout.out_num  &
   location = 228.0, 15.0  &
   height = 25.0  &
   width = 105.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   numeric_type = integer  &
   upper_check = none  &
   lower_check = gt  &
   lower_limit = 0.0
!
interface container create  &
   container_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi  &
   location = 4.0, 190.0  &
   height = 90.0  &
   width = 444.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   start_commands = "interface option_menu execute option_menu_name=o_actuation_type_multi"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.l_actuation_type  &
   location = 4.0, 4.0  &
   height = 25.0  &
   width = 120.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Actuation Type"
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.o_actuation_type_multi  &
   location = 228.0, 4.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   choices = "displacement", "velocity", "acceleration"  &
   current_choice = "displacement"  &
   commands = "variable set variable_name=$_self.memory &",  &
              " string_value=(eval($_parent.o_input_type.current_choice))",  &
              "",  &
              "variable set variable_name=.ACME.multipost.variables.flag_actuation_type &",  &
              " string_value=\"$_value\"",  &
              "",  &
              "if condition=(\"$_value\"==\"displacement\")",  &
              "   interface option_menu modify &",  &
              "    option_menu_name=$_parent.o_input_type &",  &
              "    choices=\"arbitrary solver functions\"",  &
              "",  &
              "   interface option_menu display option_menu_name=$_topgui.cont_act_type_multi.o_input_locations",  &
              "   interface label undisplay label_name=$_topgui.cont_act_type_multi.l_input_locations_wheel_spindles",  &
              "   interface option_menu execute option_menu_name=$_parent.o_input_locations",  &
              "",  &
              "!!! Change the actuator pad geometry to match the input locations.",  &
              "   acme multipost setup shape_actuators assembly=(eval($_topgui.assembly))",  &
              "",  &
              "else",  &
              "   interface option_menu modify &",  &
              "    option_menu_name=$_parent.o_input_type &",  &
              "    choices = \"arbitrary solver functions\"",  &
              "",  &
              "   interface option_menu display option_menu_name=$_topgui.cont_act_type_multi.o_input_locations",  &
              "   interface label undisplay label_name=$_topgui.cont_act_type_multi.l_input_locations_wheel_spindles",  &
              "   interface option_menu execute option_menu_name=$_parent.o_input_locations",  &
              "end",  &
              "",  &
              "if condition=(anym($_self.memory==$_parent.o_input_type.choices))",  &
              "   interface option_menu modify option_menu_name=$_parent.o_input_type &",  &
              "    current_choice=(eval($_self.memory))",  &
              "end",  &
              "",  &
              "interface option_menu execute option_menu_name=$_parent.o_input_type"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.l_input_type  &
   location = 4.0, 29.0  &
   height = 25.0  &
   width = 120.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Input Source"
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.o_input_type  &
   location = 228.0, 29.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   choices = "arbitrary solver functions"  &
   current_choice = "arbitrary solver functions"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.l_input_locations  &
   location = 4.0, 54.0  &
   height = 25.0  &
   width = 120.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Input Locations"
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.o_input_locations  &
   location = 228.0, 54.0  &
   height = 25.0  &
   width = 212.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   choices = "wheel spindles", "beneath tires"  &
   current_choice = "wheel spindles"  &
   commands = "!!! Set the flag for which set of actuators locations is desired: \"beneath tires\" or",  &
              "!!! \"wheel spindles\".",  &
              "variable set variable=.ACME.multipost.variables.flag_input_locations &",  &
              " string_value=\"$_value\"",  &
              "",  &
              "!!! Set mirror of this .ACME.multipost.variables.flag_input_locations inside of",  &
              "!!! the FOUR_POST_TESTRIG to match it. It must be maintained so that the testrig",  &
              "!!! does not directly depend on .ARIDE so that the plugin can be unloaded.",  &
              "if condition=(db_exists(eval($_topgui.assembly)//\".testrig\"))",  &
              "   variable set &",  &
              "    variable_name=(eval($_topgui.assembly)//\".testrig.phs_flag_input_locations\") &",  &
              "    string_value=(eval(.ACME.multipost.variables.flag_input_locations))",  &
              "end",  &
              "",  &
              "!!! Change the actuator pad geometry to match the input locations.",  &
              "acme multipost setup shape_actuators assembly=(eval($_topgui.assembly))"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.l_input_locations_wheel_spindles  &
   location = 233.0, 54.0  &
   height = 26.0  &
   width = 83.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "wheel spindles"
!
interface label undisplay  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_act_type_multi.l_input_locations_wheel_spindles
!
interface container create  &
   container_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs  &
   location = 4.0, 285.0  &
   height = 240.0  &
   width = 444.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   start_commands = "variable set variable_name=$_self.memory string=(eval(\"$o_sfn_units\"))",  &
                    "",  &
                    "if condition=(\"$o_actuation_type_multi\"==\"displacement\")",  &
                    "   interface option_menu modify  &",  &
                    "    option_menu_name=$_self.o_sfn_units  &",  &
                    "    choices=\"mm\",\"m\"",  &
                    "elseif condition=(\"$o_actuation_type_multi\"==\"velocity\")",  &
                    "   interface option_menu modify  &",  &
                    "    option_menu_name=$_self.o_sfn_units  &",  &
                    "    choices=\"mm/s\",\"m/s\"",  &
                    "else condition=(\"$o_actuation_type_multi\"==\"acceleration\")",  &
                    "   interface option_menu modify  &",  &
                    "    option_menu_name=$_self.o_sfn_units  &",  &
                    "    choices=\"mm/s^2\",\"m/s^2\"",  &
                    "end",  &
                    "",  &
                    "if condition=(anym($_self.memory==$_self.o_sfn_units.choices))",  &
                    "   interface option_menu modify option_menu=$_self.o_sfn_units &",  &
                    "    current_choice=(eval($_self.memory))",  &
                    "end"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_lf  &
   location = 4.0, 35.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Left Front"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_lf  &
   location = 114.0, 35.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_rf  &
   location = 4.0, 65.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Right Front"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_rf  &
   location = 114.0, 65.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_lr  &
   location = 4.0, 95.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Left Rear"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_lr  &
   location = 114.0, 95.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_rr  &
   location = 4.0, 125.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Right Rear"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_rr  &
   location = 114.0, 125.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_lr2  &
   location = 4.0, 155.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Left Rear2"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_lr2  &
   location = 114.0, 155.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_rr2  &
   location = 4.0, 185.0  &
   height = 25.0  &
   width = 100.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Right Rear2"
!
interface field create  &
   field_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.f_sfn_rr2  &
   location = 114.0, 185.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top  &
   scrollable = no  &
   editable = yes  &
   required = yes  &
   execute_cmds_on_exit = no  &
   number_of_values = 1  &
   string_type = solver_function  &
   add_quotes = except_expression
!
interface option_menu create  &
   option_menu_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.o_sfn_units  &
   location = 228.0, 210.0  &
   height = 25.0  &
   width = 75.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   choices = "mm", "m"  &
   current_choice = "mm"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_actuators_active_all  &
   location = 116.0, 104.0  &
   height = 25.0  &
   width = 10.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "all"
!
interface label undisplay  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_actuators_active_all
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_expressions  &
   location = 4.0, 4.0  &
   height = 25.0  &
   width = 200.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Solver Function Expressions:"
!
interface label create  &
   label_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.l_sfn_units  &
   location = 4.0, 210.0  &
   height = 25.0  &
   width = 150.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_top  &
   justified = left  &
   text = "Solver Function Units"
!
interface separator create  &
   separator_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.sep_1  &
   location = 4.0, 208.0  &
   width = 436.0  &
   units = pixel  &
   horiz_resizing = expand  &
   vert_resizing = attach_top
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.cont_solver_funcs.memory  &
   string_value = "mm"
!
interface toggle_button create  &
   toggle_button_name = .ACME.multipost.dboxes.acm_multi_ana_sub.t_logfile  &
   location = 4.0, 533.0  &
   height = 25.0  &
   width = 175.0  &
   units = pixel  &
   horiz_resizing = attach_left  &
   vert_resizing = attach_bottom  &
   label = "Create Analysis Log File"  &
   state = on  &
   on_value = "yes"  &
   off_value = "no"
!
interface push_button create  &
   push_button_name = .ACME.multipost.dboxes.acm_multi_ana_sub.OK  &
   location = 216.0, 574.0  &
   height = 25.0  &
   width = 76.0  &
   units = pixel  &
   horiz_resizing = attach_right  &
   vert_resizing = attach_bottom  &
   label = "OK"  &
   commands = "interface dialog execute dialog=$_parent undisplay=no",  &
              "if condition=(!$_parent.errorFlag)",  &
              "   interface dialog undisplay dialog=$_parent",  &
              "end"  &
   default = true
!
interface push_button create  &
   push_button_name = .ACME.multipost.dboxes.acm_multi_ana_sub.Apply  &
   location = 294.0, 574.0  &
   height = 25.0  &
   width = 76.0  &
   units = pixel  &
   horiz_resizing = attach_right  &
   vert_resizing = attach_bottom  &
   label = "Apply"  &
   commands = "interface dialog execute dialog=$_parent undisplay=no"
!
interface push_button create  &
   push_button_name = .ACME.multipost.dboxes.acm_multi_ana_sub.Cancel  &
   location = 372.0, 574.0  &
   height = 25.0  &
   width = 76.0  &
   units = pixel  &
   horiz_resizing = attach_right  &
   vert_resizing = attach_bottom  &
   label = "Cancel"  &
   commands = "interface dialog undisplay dialog=$_parent"
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.errorFlag  &
   integer_value = 0
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.entity_comments  &
   string_value = ""
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.updateOption  &
   integer_value = 0
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.assembly  &
   object_value = (NONE)
!
variable create  &
   variable_name = .ACME.multipost.dboxes.acm_multi_ana_sub.tmpstepcount  &
   integer_value = 100
