!USER_ENTERED_COMMAND acme multipost get acar_tire object
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! Given an assembly, a side, and front or back, return the ac_tire
! or ac_swift_tire object (if it exists).
!
! $assembly:t=model
! $side:t=list(L,R):d=L
! $front_rear:t=list(F,R,R2):d=F
! $ac_tire:t=variable
!
!END_OF_PARAMETERS
!
!
!!! See if any tires exist first. If none exist, return none for
!!! tire object. If at least one exists then all four should
!!! exist. If this is not true, an error will be signalled
!!! below.
!
variable set variable_name=$_self.all_tire_udes object_value=(none)
acar toolkit get_acar_tires &
 assembly=$assembly all_tire_udes=$_self.all_tire_udes
!
if condition=(eval($_self.all_tire_udes==(none)))
   variable set variable_name=$ac_tire object_value=(none)
   return
end
!
if condition=("$side"=="L")
   variable set variable=$_self.sideFilter string_value="til_*"
else
   variable set variable=$_self.sideFilter string_value="tir_*"
end
!
if condition=("$front_rear"=="F")
   variable set variable=$_self.minorRole string_value="front"
elseif condition=("$front_rear"=="R")
   variable set variable=$_self.minorRole string_value="rear"
else
   variable set variable=$_self.minorRole string_value="rear2"
end
!
variable set variable=$_self.wheels_subsystem &
 object_value=(eval(subsystem_lookup($assembly,"wheel",$_self.minorRole)))
  
variable set variable=$ac_tire &
 object_value=(eval(db_filter_name(db_children($_self.wheels_subsystem[1],"ac_tire"),$_self.sideFilter)))
!
if condition=(db_count($ac_tire.self, "object_value")==0)
   variable set variable=$ac_tire &
    object_value=(eval(db_filter_name(db_children($_self.wheels_subsystem[1],"ac_swift_tire"),$_self.sideFilter)))
end
!
if condition=(db_count($ac_tire.self, "object_value")==0)
   acar toolkit warning &
    warning=(eval("Error finding a tire for "//"$side"//"$front_rear"//" wheel."))
   variable set variable_name=$error_variable integer_value=1
   return
end
  
variable delete variable_name=(eval(db_children($_self,"variable")))  
