!USER_ENTERED_COMMAND acme multipost setup shape_actuators
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! Change the shape of the actuator=pad geometry to match the
! excitation input locations: either "wheel spindles" or "beneath tires".
!
! $assembly:t=model
!
!END_OF_PARAMETERS
!
!
if condition=(eval($assembly==none))
   return
end
!
variable set variable_name=$_self.cylinder_length_offset &
 real_value=50 units=mm
!
!
   !--- get the front suspension
   variable set variable=$_self.frontSusp &
    object_value=(eval(subsystem_lookup($assembly,"suspension","front")))
   variable set variable=$_self.rearSusp &
    object_value=(eval(subsystem_lookup($assembly,"suspension","rear")))
   variable set variable=$_self.rear2Susp &
    object_value=(eval(subsystem_lookup($assembly,"suspension","rear2")))
!
   variable set variable=$_self.traits &
    string_value="output", "wheel_center", "location", "l"
   variable set variable=$_self.col_wheel_center_front &
    object_value=(eval(communicator_lookup($_self.frontSusp[1],$_self.traits.self)))
   variable set variable=$_self.col_wheel_center_rear &
    object_value=(eval(communicator_lookup($_self.rearSusp[1],$_self.traits.self)))
   variable set variable=$_self.col_wheel_center_rear2 &
    object_value=(eval(communicator_lookup($_self.rear2Susp[1],$_self.traits.self)))
!
   variable set variable=$_self.traits &
    string_value="output", "wheel_center", "location", "r"
   variable set variable=$_self.cor_wheel_center_front &
    object_value=(eval(communicator_lookup($_self.frontSusp[1],$_self.traits.self)))
   variable set variable=$_self.cor_wheel_center_rear &
    object_value=(eval(communicator_lookup($_self.rearSusp[1],$_self.traits.self)))
   variable set variable=$_self.cor_wheel_center_rear2 &
    object_value=(eval(communicator_lookup($_self.rear2Susp[1],$_self.traits.self)))
!
   variable set variable_name=$_self.spindle_height_fl &
    real=(eval($_self.col_wheel_center_front.object_value.real_value[3])) units=length
!
   variable set variable_name=$_self.spindle_height_fr &
    real=(eval($_self.cor_wheel_center_front.object_value.real_value[3])) units=length
!
   variable set variable_name=$_self.spindle_height_rl &
    real=(eval($_self.col_wheel_center_rear.object_value.real_value[3])) units=length
!
   variable set variable_name=$_self.spindle_height_rr &
    real=(eval($_self.cor_wheel_center_rear.object_value.real_value[3])) units=length
!
   variable set variable_name=$_self.spindle_height_r2l &
    real=(eval($_self.col_wheel_center_rear2.object_value.real_value[3])) units=length
!
   variable set variable_name=$_self.spindle_height_r2r &
    real=(eval($_self.cor_wheel_center_rear2.object_value.real_value[3])) units=length
!
   variable set variable=$_self.frontWheel &
    object_value=(eval(subsystem_lookup($assembly,"wheel","front")))
   variable set variable=$_self.leftFrontWheel &
    object_value=(eval(db_filter_name(db_children($_self.frontWheel[1],"ac_tire"),"til_*")))
   variable set variable=$_self.rightFrontWheel &
    object_value=(eval(db_filter_name(db_children($_self.frontWheel[1],"ac_tire"),"tir_*")))
   variable set variable=$_self.rearWheel &
    object_value=(eval(subsystem_lookup($assembly,"wheel","rear")))
   variable set variable=$_self.leftRearWheel &
    object_value=(eval(db_filter_name(db_children($_self.rearWheel[1],"ac_tire"),"til_*")))
   variable set variable=$_self.rightRearWheel &
    object_value=(eval(db_filter_name(db_children($_self.rearWheel[1],"ac_tire"),"tir_*")))
   variable set variable=$_self.rear2Wheel &
    object_value=(eval(subsystem_lookup($assembly,"wheel","rear2")))
   variable set variable=$_self.leftRear2Wheel &
    object_value=(eval(db_filter_name(db_children($_self.rear2Wheel[1],"ac_tire"),"til_*")))
   variable set variable=$_self.rightRear2Wheel &
    object_value=(eval(db_filter_name(db_children($_self.rear2Wheel[1],"ac_tire"),"tir_*")))
!
   variable set variable_name=$_self.tire_radius_fl &
    real=(eval($_self.leftFrontWheel.tire_radius.real_value)) units=length
   variable set variable_name=$_self.tire_radius_fr &
    real=(eval($_self.rightFrontWheel.tire_radius.real_value)) units=length
   variable set variable_name=$_self.tire_radius_rl &
    real=(eval($_self.leftRearWheel.tire_radius.real_value)) units=length
   variable set variable_name=$_self.tire_radius_rr &
    real=(eval($_self.rightRearWheel.tire_radius.real_value)) units=length
   variable set variable_name=$_self.tire_radius_r2l &
    real=(eval($_self.leftRear2Wheel.tire_radius.real_value)) units=length
   variable set variable_name=$_self.tire_radius_r2r &
    real=(eval($_self.rightRear2Wheel.tire_radius.real_value)) units=length
!
if condition=(eval(.ACME.multipost.variables.flag_input_locations)=="wheel spindles")
   !!! Make the pads into slender cylinders that extend to the wheel spindles.
   variable set variable_name=$_self.cylinder_radius &
    real_value=30 units=mm
!
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_front.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_fl - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_front.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_fr - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_rear.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_rl - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_rear.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_rr - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))

   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_rear2.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_r2l - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_rear2.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset + $_self.spindle_height_r2r - $assembly.testrig.ground.std_tire_ref.loc[3])) &
    radius=(eval($_self.cylinder_radius))
!
else
   !!! Make the pads into chubby disks with contact surfaces at Z=0.   
   variable set variable_name=$_self.cylinder_radius &
    real_value=200 units=mm
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_front.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_front.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_rear.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius+$assembly.testrig.dual_wheel_offset_rear/2))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_rear.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius+$assembly.testrig.dual_wheel_offset_rear/2))

   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.gel_mount_post_pad_vertical_rear2.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius+$assembly.testrig.dual_wheel_offset_rear2/2))
    
   geometry modify shape cylinder &
    cylinder_name=(eval($assembly.testrig.ger_mount_post_pad_vertical_rear2.gracyl_pad)) &
    length=(eval($_self.cylinder_length_offset)) &
    radius=(eval($_self.cylinder_radius+$assembly.testrig.dual_wheel_offset_rear2/2))
!
end
!
!!! Move the tire reference markers into the actuator pads.
acme multipost setup tire_reference_markers assembly=$assembly
!
variable delete variable_name=(eval(db_children($_self,"variable")))
