!
! Adams Car
! Copyright (C) 2016 MSC Software Corporation
! All Rights Reserved.
!
!*******************************************************************
!
! $assembly:t=model
! $analysis_name:t=string
! $end_time:t=real:gt=0
! $number_of_steps:t=integer:gt=0
! $analysis_mode:t=list(interactive,graphical,background,files_only):d=interactive
! $load_results:t=list(yes,no):u=yes
! $brief:t=list(on,off):u=off
! $caller:t=string:d="other"
! $road_data_file:t=file(*.rdf):c=0
! $update_road_height:t=list(yes,no):d=yes
! $moving_road:t=list(yes,no):d=no
! $generate_road_geometry:t=list(yes,no):d=yes
! $simulation_type:t=string:d=dynamic
! $batch_control:t=integer:c=2:d=1,1
! $batch_prefix:t=string:d="./tmp_acar_batch"
! $acf_spmm:t=string:d=""
! $error_variable:t=variable:d=.ACAR.variables.errorFlag
!
!END_OF_PARAMETERS
!---- $brief variable removed when the sdi was implemented, remains here to support legacy code
!
if condition=(db_exists("$assembly.testrig"))
if condition=(!db_active($assembly.testrig))
variable set variable=$_self.ask integer=(eval(alert("question","The testrig has been deactivated. Do you wish to activate it now?","Yes","No","Abort",1)))
! 1 = activate the testrig and continue with the analysis
! 2 = do not activate the testrig, but continue with the analysis
! 3 = abort now
if condition=($_self.ask == 1)
acar files assembly subsystem activate subsystem_name=$assembly.testrig
elseif condition=($_self.ask == 3)
variable set variable_name=$error_variable integer=1
return
end
end
end
!
if condition=("$caller" == "other")
interface model_browser set auto_refresh=off
end
!
variable delete variable=(eval(db_children($_self,"variable")))
variable create variable=$_self.batchAnalysis integer=$batch_control
variable create variable=$_self.leafspringFlag string="false"
variable create variable=$_self.smartRoad integer=(eval(getenv("MSC_ACAR_SMART_ROAD") == "yes" ? 1 : 0))
variable create variable=$_self.aiRun integer=(eval(rows(db_filter_name(db_children(.mdi.ai,"variable"),"nT")) > 0))
!
!---- adjustable forces (1/2 - model prep) ----
variable set variable=$_self.afo_cnt integer=0
variable set variable=$_self.afo_obj object=(none)
variable set variable=$_self.afo_align integer=0
!
if condition=(rows(db_children($assembly,"ac_aforce")))
for variable=$_self.the_obj obj=(eval(db_children($assembly,"ac_aforce"))) type=ac_aforce
if condition=(db_active($_self.the_obj) && $_self.the_obj[1].adjustment.integer_value)
variable set variable=$_self.afo_cnt &
integer=(eval($_self.afo_cnt + 1))
variable set variable=$_self.afo_obj &
object=(eval($_self.the_obj)) &
index=(eval($_self.afo_cnt))
if condition=(!$_self.afo_align)
variable set variable=$_self.afo_align integer=1
end
end
end
if condition=($_self.afo_cnt.integer_value)
!---- For analysis on testrig-less assembly, example GAA analysis
if condition=(db_exists("$assembly.testrig"))
if condition=(!db_exists("$assembly.testrig.adjustable_force_array"))
data_element create array general_array &
adams_id=(eval(unique_id("adams_array"))) &
array_name=$assembly.testrig.adjustable_force_array &
size=1 numbers=0.0
end
data_element modify array general_array &
array_name=$assembly.testrig.adjustable_force_array &
size=(eval($_self.afo_cnt)) &
numbers=(eval(series2(0.0,0.0,$_self.afo_cnt)))
!
for variable=$_self.loopcnt start=1 end=(eval($_self.afo_cnt))
$assembly.testrig.adjustable_force_array.numbers[$_self.loopcnt] = (eval($_self.afo_obj[$_self.loopcnt]).array.adams_id)
variable set variable=$_self.afo_txt &
string=(eval("ID of '"//str_delete($_self.afo_obj[$_self.loopcnt].name,1,4)//"' adjustable force array")) &
index=(eval($_self.loopcnt))
end
data_element modify array general_array &
array_name=$assembly.testrig.adjustable_force_array &
comments=(eval($_self.afo_txt))
variable set variable_name=$_self.adjuster_array object=$assembly.testrig.adjustable_force_array
!
else
if condition=(!db_exists("$assembly.adjustable_force_array"))
data_element create array general_array &
adams_id=(eval(unique_id("adams_array"))) &
array_name=$assembly.adjustable_force_array &
size=1 numbers=0.0
end
data_element modify array general_array &
array_name=$assembly.adjustable_force_array &
size=(eval($_self.afo_cnt)) &
numbers=(eval(series2(0.0,0.0,$_self.afo_cnt)))
!
for variable=$_self.loopcnt start=1 end=(eval($_self.afo_cnt))
$assembly.adjustable_force_array.numbers[$_self.loopcnt] = (eval($_self.afo_obj[$_self.loopcnt]).array.adams_id)
variable set variable=$_self.afo_txt &
string=(eval("ID of '"//str_delete($_self.afo_obj[$_self.loopcnt].name,1,4)//"' adjustable force array")) &
index=(eval($_self.loopcnt))
end
data_element modify array general_array &
array_name=$assembly.adjustable_force_array &
comments=(eval($_self.afo_txt))
variable set variable_name=$_self.adjuster_array object=$assembly.adjustable_force_array
end
else
if condition=(db_exists("$assembly.testrig.adjustable_force_array"))
data_element delete &
data_element_name=$assembly.testrig.adjustable_force_array
end
if condition=(db_exists("$assembly.adjustable_force_array"))
data_element delete &
data_element_name=$assembly.adjustable_force_array
end
end
end
variable set variable=$_self.loa_cnt integer=0
variable set variable=$_self.loa_obj object=(none)
if condition=($_self.afo_cnt && $_self.afo_align)
for variable=$_self.the_obj obj=(eval(db_filter_name(db_children($assembly,"part"),"gesloa_*"))) type=part
if condition=($_self.the_obj[1].active.integer_value == 1 && $_self.the_obj[1].alignment.integer_value == 0)
variable set variable=$_self.loa_cnt &
integer=(eval($_self.loa_cnt + 1))
variable set variable=$_self.loa_obj &
object=(eval($_self.the_obj)) &
index=(eval($_self.loa_cnt))
end
end
if condition=($_self.loa_cnt.integer_value)
if condition=(!db_exists("$assembly.adjustable_loading_array"))
data_element create array general_array &
adams_id=(eval(unique_id("adams_array"))) &
array_name=$assembly.adjustable_loading_array &
size=1 numbers=0.0
end
data_element modify array general_array &
array_name=$assembly.adjustable_loading_array &
size=(eval($_self.loa_cnt)) &
numbers=(eval(series2(0.0,0.0,$_self.loa_cnt)))
for variable=$_self.loopcnt start=1 end=(eval($_self.loa_cnt))
$assembly.adjustable_loading_array.numbers[$_self.loopcnt] = (eval($_self.loa_obj[$_self.loopcnt]).adams_id)
variable set variable=$_self.afo_txt &
string=(eval("ID of '"//str_delete($_self.loa_obj[$_self.loopcnt].name,1,7)//"' loading object")) &
index=(eval($_self.loopcnt))
end
data_element modify array general_array &
array_name=$assembly.adjustable_loading_array &
comments=(eval($_self.afo_txt))
!
else
if condition=(db_exists("$assembly.adjustable_loading_array"))
data_element delete &
data_element_name=$assembly.adjustable_loading_array
end
end
else
if condition=(db_exists("$assembly.adjustable_loading_array"))
data_element delete &
data_element_name=$assembly.adjustable_loading_array
end
end
!
!---- Set adaptive output or warn if settings don't match model content ----
acar toolkit set output &
model=$assembly &
analysis_mode=$analysis_mode
!
if condition=(db_object_count(db_children($assembly, "flexible_body"))>0)
! temporary work around for CR 1-FDB48450, if ip's exist, make sure they have cm's
for variable=$_self.loopobj object=(eval(db_filter_name(db_children($assembly,"part"),"ip[lrs]_*")))
if condition=(!db_exists($_self.loopobj.object_value.cm))
part modify rigid_body mass_properties &
part_name = (eval($_self.loopobj.object_value)) &
center_of_mass_marker = (eval($_self.loopobj.object_value.interface_i))
end
end
end
!
!-- Body stakes (flex body frame)
if condition=(anym($assembly.event_class == "__MDI_SDI_TESTRIG"))
if condition=(db_type($assembly.testrig.cis_body_subsystem[2]) == "Flexible_Body")
marker modify marker=($assembly.testrig.josinl_body_stake.j) &
location=(aggregate_mass($assembly.testrig.cis_body_subsystem[2],$assembly.ground.origo,"cm_pos"))
marker modify marker=($assembly.testrig.josinl_body_stake.i) &
node_id=(eval(node_id_closest($assembly.testrig.josinl_body_stake.j, $assembly.testrig.cis_body_subsystem[2], 1)))
marker modify marker=($assembly.testrig.josinl_body_stake.j) &
location=(LOC_RELATIVE_TO({0,0,0},$assembly.testrig.josinl_body_stake.i))
marker modify marker=($assembly.testrig.josper_yaw_stake.i) &
node_id=(eval(node_id_closest($assembly.testrig.josinl_body_stake.j, $assembly.testrig.cis_body_subsystem[2], 1)))
marker modify marker=($assembly.testrig.josper_yaw_stake.j) &
location=(LOC_RELATIVE_TO({0,0,0},$assembly.testrig.josper_yaw_stake.i))
end
! keep in sync with the acf processing below
elseif condition=("$simulation_type" == "static_only" || str_match("sdi*", "$simulation_type") || str_match("carat_*", "$simulation_type") || "$simulation_type" == "svc")
acar toolkit warning type=error warning=&
"A simulation type 'static_only', 'sdi*', 'carat_*' or 'svc'", &
"requires a vehicle assembly with an SDI compatible testrig."
variable delete variable=(eval(db_children($_self,"variable")))
variable set variable=$error_variable integer=1
return
end
!
!---- Contact Definitions (1/2 - prior to conditional road generation; can be eliminated once roads are generated prior to analysis always again) ----
variable set variable=$_self.rcdCnt integer=0
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_contact_definition")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime" && $_self.loopobj.object_value.matching_name.string_value == "road_shell")
variable set variable=$_self.rcdCnt integer=(eval($_self.rcdCnt+1))
end
end
!---- Add in the number of runtime clearance objects
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_runtime_clearance")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime" && $_self.loopobj.object_value.matching_name.string_value == "road_shell")
variable set variable=$_self.rcdCnt integer=(eval($_self.rcdCnt+1))
end
end
!---- Update the road height ----
if condition=($update_road_height)
acar analysis full_vehicle road set_height &
assembly=$assembly &
coincident_xy=(eval(anym("$simulation_type" == {"spmm","multipost","fourpost_vib","tilt_table"}) ? "no" : "yes")) &
units_string=(eval(units_value("length")))
end
!
!!! Set the moving road flag. Then update any SWIFT tires accordingly.
variable set variable_name=.ACAR.moving_road string_value=$moving_road
!
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_tire")))
!!! Set the moving road flag. Then update any ac_tire accordingly.
acar template_builder instance ac_tire reset instance_name=(eval($_self.loopobj))
acar standard_interface instance ac_tire force_graphics_initialize instance_name=(eval($_self.loopobj))
end
!
if condition=($generate_road_geometry && !$_self.aiRun)
!
if condition=($_self.smartRoad == 1 && "$analysis_mode" == "interactive" && $_self.rcdCnt == 0)
!---- Purge superimposed path lines ----
if condition=(db_exists("$assembly.road_filename"))
variable modify variable=$assembly.road_filename index=2 string=" "
end
if condition=(rows(db_filter_name(db_children($assembly.ground,"shell"),"Lines_*")) > 0)
geometry delete geometry=(eval(db_filter_name(db_children($assembly.ground,"shell"),"Lines_*")))
end
!---- Check for existence of the road data file now, road generated later ----
acar toolkit check road_data_file &
road_data_file="$road_data_file" &
error_variable=$error_variable
else
!---- Generate the road geometry ----
acar toolkit road generate_geometry &
road_data_file="$road_data_file" &
road_reference_marker=$assembly.testrig.ground.std_tire_ref &
assembly=$assembly &
superimpose=purge &
write_shl_file=(eval(yes_no($_self.rcdCnt))) &
error_variable=$error_variable
!
end
!
if condition=($error_variable != 0)
variable delete variable_name=(eval(db_children($_self,"variable")))
return
end
!
end
!
!---- Contact Definitions ----
for variable=$_self.loopobj object=(eval(db_children($assembly,"ac_contact_definition")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime")
variable set variable=$_self.traits &
string="output", &
(eval($_self.loopobj.object_value.matching_name.string_value)), &
(eval($_self.loopobj.object_value.object_type.string_value)), &
(eval(str_substr($_self.loopobj.object_value.name,3,1)))
for variable=$_self.loopmod object=(eval(db_children($assembly,"model")))
variable set variable=$_self.rcdMatch &
object=(eval(COMMUNICATOR_LOOKUP($_self.loopmod.object_value,$_self.traits.self)))
if condition=(db_exists($_self.rcdMatch))
break
elseif condition=($_self.traits[4] != "s")
$_self.traits.string_value[4]="s"
variable set variable=$_self.rcdMatch &
object=(eval(COMMUNICATOR_LOOKUP($_self.loopmod.object_value,$_self.traits.self)))
if condition=(db_exists($_self.rcdMatch))
break
end
end
end
if condition=(db_exists($_self.rcdMatch))
variable set variable=($_self.loopobj.object_value.j_contact_body) &
object=(eval($_self.rcdMatch.object_value))
end
end
acar standard_interface instance ac_contact_definition repair instance_name=($_self.loopobj.object_value)
end
!
!---- Runtime Clearance Definitions ----
for variable=$_self.loopobj object=(eval(db_children($assembly,"ac_runtime_clearance")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime")
variable set variable=$_self.traits &
string="output", &
(eval($_self.loopobj.object_value.matching_name.string_value)), &
(eval($_self.loopobj.object_value.object_type.string_value)), &
(eval(str_substr($_self.loopobj.object_value.name,3,1)))
for variable=$_self.loopmod object=(eval(db_children($assembly,"model")))
variable set variable=$_self.rcdMatch &
object=(eval(COMMUNICATOR_LOOKUP($_self.loopmod.object_value,$_self.traits.self)))
if condition=(db_exists($_self.rcdMatch))
break
elseif condition=($_self.traits[4] != "s")
$_self.traits.string_value[4]="s"
variable set variable=$_self.rcdMatch &
object=(eval(COMMUNICATOR_LOOKUP($_self.loopmod.object_value,$_self.traits.self)))
if condition=(db_exists($_self.rcdMatch))
break
end
end
end
if condition=(db_exists($_self.rcdMatch))
variable set variable=($_self.loopobj.object_value.j_contact_body) &
object=(eval($_self.rcdMatch.object_value))
end
end
acar standard_interface instance ac_runtime_clearance repair instance_name=($_self.loopobj.object_value)
end
!
!---- Special tuning, set gear IC to current value ----
variable set variable=$_self.gear_demand &
string=(eval(get_actuator_instance($assembly,"driver_demand","gear","vas_*")))
if condition=(db_exists($_self.gear_demand.string_value))
if condition=("$simulation_type" != "static_only" && !str_match("sdi*", "$simulation_type") && "$simulation_type" != "svc")
if condition=(db_exists("$assembly.sse_simulation_type"))
if condition=(!(anym($assembly.sse_simulation_type == {"ssa","sss","mmm"})))
acar template_builder actuator set function &
actuator=(eval($_self.gear_demand)) &
function="3.0"
end
else
acar template_builder actuator set function &
actuator=(eval($_self.gear_demand)) &
function="3.0"
end
end
data_element modify variable &
variable_name=(eval($_self.gear_demand//".variable")) &
initial_condition=(eval(stor(stoo($_self.gear_demand).function.string_value)))
end
!
!---- Display the model ----
model display &
model_name=$assembly &
fit_to_view=no
view zoom &
auto_zoom=no_ground
!
!---- Update rpf file and simulation_type strings ----
default prompting_level wildcard_messages=none
variable set variable=$_self.ftirecnt integer=0
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_tire")))
if condition=(!db_exists($_self.loopobj[1]//".user_specified_road"))
data_element modify string &
string_name=(eval($_self.loopobj[1].rpf_file)) &
string=(eval(cdb_input2tblpth("$road_data_file")))
end
!-- Make sure Ftire-only roads are not used with active non-Ftire instances
if condition=(DB_ACTIVE($_self.loopobj.object_value))
if condition=(TIRE_PROPFILE_FORMAT($_self.loopobj.object_value.property_file.string_value) == "FTIRE")
variable set variable=$_self.ftirecnt integer=(eval($_self.ftirecnt+1))
else
if condition=(anym(CDB_INPUT2EXT($_self.loopobj.object_value.rpf_file.string)=={"crm","urm","usm"}))
acar toolkit warning type=error warning=&
"Road properties of type 'crm', 'urm' or 'usm' are only supported in combination with Ftire.", &
(eval("Please correct '"//$_self.loopobj.object_value//"' (and other ac_tire instances as needed)."))
variable delete variable_name=(eval(db_children($_self,"variable")))
return
end
end
end
data_element modify string &
string_name=(eval($_self.loopobj[1].simulation_type)) &
string="VEHICLE_HANDLING_DYNAMIC"
end
default prompting_level wildcard_messages=all
!
!---- Set prefix here already so custom macros can overwrite ----
simulation set &
file_prefix=(eval(str_filename("$analysis_name.acf",".acf","")))
!
!---- Execute pre-analysis customization macro ----
for variable=$_self.custom_macro object_names=(eval(DB_FILTER_NAME(DB_CHILDREN(0, "macro" ),$_self.name//"_custom_pre")))
if condition=(db_oldest_ancestor($_self.custom_macro.object_value,"library").name == "carat")
acar customize analysis full_vehicle submit prepro &
assembly=$assembly analysis_name=(eval(.sim_preferences.file_prefix)) simulation_type=$simulation_type
else
variable set variable=$_self.execCommand integer_value= &
(eval(execute_view_command($_self.custom_macro[1].user_command//" assembly=$assembly analysis_name="//.sim_preferences.file_prefix//" simulation_type=$simulation_type")))
end
end
!
!---- Setup Truck UDEs
if condition=(db_exists(".MDI.plugins.atruck"))
for variable=$_self.the_rhs object_names=(eval(DB_CHILDREN($assembly, "ac_truck_rhs")))
variable modify variable=($_self.the_rhs.object_value.fixed_diffeq_active) integer=(ROWS(db_filter_type(DB_DELETE_DEPENDENTS(eval($_self.the_rhs.object_value.airspring_preload_fixed)),"analysis_function")) == 0 ? 0 : 1)
variable modify variable=($_self.the_rhs.object_value.variable_diffeq_active) integer=(ROWS(db_filter_type(DB_DELETE_DEPENDENTS(eval($_self.the_rhs.object_value.airspring_preload_variable)),"analysis_function")) == 0 ? 0 : 1)
end
end
!
!---- Set Initial Conditions - CR 1-FDB49771 ----
if condition=(db_exists(".ACAR.macros.mac_too_set_ini"))
acar toolkit setup initial_condition &
assembly=$assembly
end
!
!---- Generate adams_id's (after model changes and before writing the acf) ----
if condition=("$analysis_mode" == "background")
!---- Write adm-file ----
acar toolkit message &
message="Writing assembly information to Adams Solver dataset..."
file adams_data_set write &
file_name=(eval(.sim_preferences.file_prefix)) &
model_name=$assembly
else
!---- Regenerate the adams_ids ----
interface message threshold=fault
model generate_ids &
model_names=$assembly
interface message threshold=warning
end
!
!---- Write out the request name mapping file ----
if condition=($assembly.analysis_flags.output_reqsave || getenv("MDI_ACAR_WRITE_NAM") == "yes" )
variable set variable=$_self.name_file &
integer=(eval(output_req_names($assembly, .sim_preferences.file_prefix//".nam")))
end
!
!---- Set-Up common header for all acf's ----
!
!-- adm and output prefix --
variable create variable=$_self.acf_header &
string=(eval(.sim_preferences.file_prefix//".adm")), &
(eval(.sim_preferences.file_prefix))
!
!-- SimManager info --
variable modify variable=$_self.acf_header string="!" &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header &
string=(eval("!INFO Adams Version: "//prod_info("product_line"))) &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header &
string=(eval("!INFO Adams Build: "//prod_info("build"))) &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header &
string=(eval("!INFO Assembly File: "//str_replace_all(cdb_nt2unix_path($assembly.assembly_file),"//","/"))) &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header &
string=(eval("!INFO Solver Library: "//str_replace_all(cdb_nt2unix_path(getenv("MDI_SOLVER_USER_LIB")),"//","/"))) &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header string="!" &
index=(eval(rows($_self.acf_header)+1))
!
!-- event file string --
if condition=("$simulation_type" == "static_only" || str_match("sdi*", "$simulation_type") || str_match("carat_*", "$simulation_type") || "$simulation_type" == "svc")
variable modify variable=$_self.acf_header &
string=(eval("string/"//$assembly.testrig.smart_driver_filename.adams_id//", string="//(getenv("MDI_CDB_EXPAND_PATH") == "yes" ? cdb_input2full($assembly.testrig.smart_driver_filename.string) : $assembly.testrig.smart_driver_filename.string))) &
index=(eval(rows($_self.acf_header)+1))
end
!
!---- Handle IC_couplers
if condition=(db_object_count(db_filter_name(db_children($assembly, "coupler"), "IC_coupler_*")))
variable set variable=$_self.IC_couplers object=(eval(db_filter_name(db_children($assembly, "coupler"), "IC_coupler_*")))
if condition=(!db_exists("$assembly.IC_setup"))
! find adams_ids of each coupler and stuff in a string var
variable set variable=$_self.count integer=0
for variable=$_self.tmp object=(eval($_self.IC_couplers.object_value))
variable set variable=$_self.count integer = (eval($_self.count + 1))
variable set variable=$_self.ids &
string=(eval($_self.tmp.object_value.id)) &
index=(eval($_self.count))
end
! create the IC_coupler array
data_element create array ic_array &
array_name=$assembly.IC_couplers &
numbers=(eval($_self.ids))
! create a state variable to call con1402
data_element create variable &
variable_name=$assembly.IC_setup &
user_function=1402, 0,0,0, ($assembly.IC_couplers.id) &
routine="abgVDM::var1402"
end
end
!
!-- solver preferences --
variable set variable=$_self.solpref string= &
(eval(!anym(getenv("MDI_SOLVER_SELECT") == {"F77","CXX"}) ? .acar.variables.SolverDefault : str_case(getenv("MDI_SOLVER_SELECT"),1)))
!
if condition=($_self.solpref == "F77")
!---- Check for presence of array named "IC_couplers"
if condition=(db_exists("$assembly.IC_couplers"))
variable set variable=$_self.choice integer=0
acar toolkit prompt &
warning = &
"IC coupler(s) were found, which cannot be deactivated at run-time", &
"by F77 Solver. Do you want to:", "", &
" - Switch to C++ Solver - deactivates the coupler(s) for dynamics only", &
" - Deactivate the coupler(s) now - may cause static convergence issues", &
" - Proceed with active coupler(s) - removes the gear compliance" &
button1 = "Use C++ Solver" &
button2 = "Deactivate coupler(s)" &
button3 = "Proceed" &
type = question &
return_variable=$_self.choice
!
if condition=($_self.choice == 1)
variable set variable=$_self.solpref string="CXX"
variable delete variable=$_self.IC_couplers
elseif condition=($_self.choice == 2)
entity attributes &
entity_name=(eval($_self.IC_couplers.object_value)), $assembly.IC_setup &
active=off
else
variable delete variable=$_self.IC_couplers
entity attributes &
entity_name=$assembly.IC_setup &
active=off
end
end
end
!
variable modify variable=$_self.acf_header &
string=(eval("preferences/solver="//$_self.solpref)) &
index=(eval(rows($_self.acf_header)+1))
if condition=(anym(getenv("MSC_ACAR_SIM_FAIL") == {"stopcf","nostopcf"}))
variable modify variable=$_self.acf_header &
string=(eval("preferences/simfail="//str_case(getenv("MSC_ACAR_SIM_FAIL"),2))) &
index=(eval(rows($_self.acf_header)+1))
end
!
!-- status message --
if condition=($_self.solpref != "F77")
variable modify variable=$_self.acf_header &
string="preferences/list,status=on" &
index=(eval(rows($_self.acf_header)+1))
if condition=(anym(getenv("MDI_SOLVER_CORRECTOR") == {"original","modified"}))
variable modify variable=$_self.acf_header &
string=(eval("integrator/corrector="//getenv("MDI_SOLVER_CORRECTOR"))) &
index=(eval(rows($_self.acf_header)+1))
end
end
if condition=($_self.ftirecnt > 0)
if condition=($assembly.Analysis_flags.hmax_time_step == 0.0 || $assembly.Analysis_flags.hmax_time_step > 0.001)
variable modify variable=$_self.acf_header &
string=(eval("integrator/hmax=0.001 ! FTire requirement")) &
index=(eval(rows($_self.acf_header)+1))
end
end
!
!-- custom acar.acf processing (e.g. solver settings override) --
if condition=(file_exists("acar.acf"))
variable set variable=$_self.acar_acf &
string=(eval(unique_local_name(.ACAR,"acar_acf")))
macro read &
macro_name=(eval($_self.acar_acf)) &
file_name="acar.acf"
if condition=(db_exists($_self.acar_acf//".commands"))
variable modify variable=$_self.acf_header &
index=(eval(rows($_self.acf_header)+1)) &
string="!-- Imported from acar.acf", &
(eval(stoo($_self.acar_acf).commands)), &
"!-- Import end"
end
macro delete macro=(eval($_self.acar_acf))
end
!
!-- show solver settings --
if condition=(getenv("MSC_SHOW_STATUS")=="yes")
variable modify variable=$_self.acf_header &
string="equilibrium/list" &
index=(eval(rows($_self.acf_header)+1))
variable modify variable=$_self.acf_header &
string="integrator/list" &
index=(eval(rows($_self.acf_header)+1))
end
!
!-- SPMM initial settings --
if condition=("$simulation_type" == "SPMM")
variable modify variable=$_self.acf_header &
string=(eval("deactivate/motion,range="//$assembly.testrig.MOTION_Trans_z.adams_id//","//$assembly.testrig.MOTION_Rot_x.adams_id)) &
index=(eval(rows($_self.acf_header)+1))
end
!
if condition=($_self.ftirecnt > 0)
variable modify variable=$_self.acf_header &
string=(eval("control/routine=abgTire::cfinit,func=user("//$assembly.file_prefix.adams_id//","//.ACAR.variables.WriteFTireRGU//","//.ACAR.variables.WriteFTireOGL[1]//","//.ACAR.variables.WriteFTireOGL[2]//")")) &
index=(eval(rows($_self.acf_header)+1))
end
!
!-- tire inertia and mass re-distribution (sorted by gforce adams_id) --
variable set variable=$_self.tirecnt integer=0
variable set variable=$_self.ghostcnt integer=0
for variable=$_self.loopobj object=(eval(db_children($assembly,"ac_tire")))
if condition=(db_active($_self.loopobj.object_value) && db_exists($_self.loopobj.object_value//".tpf_file"))
variable set variable=$_self.tirecnt integer=(eval($_self.tirecnt+1))
variable set variable=$_self.tirinst index=(eval($_self.tirecnt)) object=(eval($_self.loopobj.object_value))
variable set variable=$_self.tirfoid index=(eval($_self.tirecnt)) integer=(eval($_self.loopobj.object_value.force.adams_id))
if condition=($_self.loopobj.object_value.input_array.numbers[19] >= 0.0)
variable set variable=$_self.ghostcnt integer=(eval($_self.ghostcnt+1))
end
end
end
variable set variable=$_self.tireavg real=0.0 ! nominal average tire load
if condition=($_self.ghostcnt > 0)
variable set variable=$_self.avgtirload &
real=(eval(ac_info_mass($assembly)*9.80665(N/kg)/$_self.ghostcnt))
end
if condition=($_self.tirecnt > 0)
variable set variable=$_self.tirenum integer=(eval(sort_index($_self.tirfoid,"a")))
for variable=$_self.loopcnt start=1 end=(eval($_self.tirecnt))
variable set variable=$_self.tirobj object=(eval($_self.tirinst.object_value[$_self.tirenum[$_self.loopcnt]]))
variable modify variable=$_self.acf_header index=(eval(rows($_self.acf_header)+1)) string= &
(eval("control/routine=abgTire::con901,func=user(901,"//$_self.tirobj.object_value.tpf_file.adams_id//","//$_self.tirobj.object_value.i_marker.object_value.parent.adams_id//","//$_self.tirobj.object_value.belt_part.adams_id//",1,"//$_self.tirobj.object_value.force.adams_id//")"))
if condition=(anym(getenv("MSC_ADAMS_TIRE_GHOSTS")=={"1","on","yes"}) && $_self.tirobj.object_value.input_array.numbers[19] >= 0.0)
variable set variable=$_self.execCommand integer=(eval(execute_view_command($_self.tirobj.object_value//".input_array.numbers[19]="//$_self.avgtirload)))
end
end
end
!
!-- leaf springs --
if condition=($_self.leafspringFlag == "true")
variable set variable=$_self.leafAdjustmentCount integer=0
for var=$_self.static_steps start=1 end=(eval($assembly.cis_leaf_adjustment_steps))
variable set variable=$_self.leafAdjustmentCount integer=(eval($_self.leafAdjustmentCount+1))
variable modify variable=$_self.acf_header &
string="simulate/static", &
(eval("array/"//$assembly.leaf_adjustment_multiplier.adams_id//", num="//str_sprintf(%4.2f,$_self.leafAdjustmentCount/$assembly.cis_leaf_adjustment_steps))) &
index=(eval(rows($_self.acf_header)+1))
end
end
!
!-- adjustable forces (2/2 - acf block) --
if condition=($_self.afo_cnt.integer_value)
!
if condition=("$simulation_type" == "sse" || str_match("sdi*", "$simulation_type"))
variable modify variable=$_self.acf_header &
string="output/nosep" &
index=(eval(rows($_self.acf_header)+1))
variable set variable=$_self.sdiInitialized &
integer_value=1
end
if condition=($_self.loa_cnt.integer_value)
if condition=(db_exists(".ACAR.variables.svsFlag"))
variable modify variable=$_self.acf_header &
string=(eval("control/routine=abgFDM::con900, function=user("//$_self.adjuster_array[1].adams_id//","//$assembly.adjustable_loading_array.adams_id//","//.ACAR.variables.svsFlag//")")) &
index=(eval(rows($_self.acf_header)+1))
else
variable modify variable=$_self.acf_header &
string=(eval("control/routine=abgFDM::con900, function=user("//$_self.adjuster_array[1].adams_id//","//$assembly.adjustable_loading_array.adams_id//")")) &
index=(eval(rows($_self.acf_header)+1))
end
else
variable modify variable=$_self.acf_header &
string=(eval("control/routine=abgFDM::con900, function=user("//$_self.adjuster_array[1].adams_id//")")) &
index=(eval(rows($_self.acf_header)+1))
end
!
if condition=("$simulation_type" == "dynamic" || str_match("adriveline_*","$simulation_type"))
if condition=(db_exists("$assembly.testrig.josinl_body_stake"))
variable modify variable=$_self.acf_header &
string="output/nosep", &
(eval("deactivate/jprim, id="//$assembly.testrig.josinl_body_stake.adams_id))
index=(eval(rows($_self.acf_header)+1))
end
end
end
!----
!
!---- Write header information to acf file ----
file text open file=(.sim_preferences.file_prefix//".acf") &
open_mode=overwrite
for variable=$_self.loopcnt start=1 end=(eval(rows($_self.acf_header)))
file text write format=(eval($_self.acf_header[$_self.loopcnt]))
end
!
!---- Write analysis information to acf file ----
!*******************************************************************************
if condition=("$simulation_type" == "dynamic")
!*******************************************************************************
!
if condition=($_self.leafspringFlag != "true")
file text write format="simulate/statics"
end
if condition = (db_exists("$assembly.no_initial_velocity"))
file text write format="control/routine=abgVDM::con910, &"
file text write format=" function=user(910,%d,%G,0.0,0.0,0,0,0,%d)" &
value=($assembly.ground.origo.adams_id), &
($assembly.speed), &
(-$assembly.no_initial_velocity.adams_id)
else
file text write format="control/routine=abgVDM::con910, function=user(910,%d,%G,0.0,0.0)" &
value=($assembly.ground.origo.adams_id), &
($assembly.speed)
end
file text write format="simulate/dynamics, end=$end_time, steps=$number_of_steps"
!
!*******************************************************************************
elseif condition=("$simulation_type" == "sse")
!*******************************************************************************
!
if condition=(!db_exists("$_self.sdiInitialized"))
file text write format="output/nosep"
end
if condition=($assembly.sse_simulation_type == "ssc")
file text write format="control/routine=abgVDM::con1031, function=user(1031,%d,%d,%2G,0,%2G,%d,%2G,%2G,%d,%d,%d,1,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.sse_brake_flag), &
($assembly.sse_desired_longitudinal_accel), &
($assembly.sse_final_lateral_g), &
($assembly.sse_number_of_steps), &
($assembly.sse_turn_radius), &
($assembly.sse_bank_angle), &
(db_type($assembly.testrig.cis_body_subsystem[2])=="Flexible_Body"? (ADAMS_ID($assembly.testrig.josinl_body_stake.i)):($assembly.testrig.sse_body_cm_adams_id)), &
($assembly.testrig.cis_steering_wheel_joint.object_value.i.adams_id), &
($assembly.testrig.cis_steering_wheel_joint.object_value.j.adams_id), &
($assembly.ground.origo.adams_id)
elseif condition=($assembly.sse_simulation_type == "sss")
file text write format="control/routine=abgVDM::con1032, function=user(1032,%d,0,%2G,%G,%2G,%d,%2G,%d,%d,%d,1,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.sse_desired_longitudinal_accel), &
($assembly.speed), &
($assembly.sse_final_lateral_g), &
($assembly.sse_number_of_steps), &
($assembly.sse_bank_angle), &
(db_type($assembly.testrig.cis_body_subsystem[2])=="Flexible_Body"? (ADAMS_ID($assembly.testrig.josinl_body_stake.i)):($assembly.testrig.sse_body_cm_adams_id)), &
($assembly.testrig.cis_steering_wheel_joint.object_value.i.adams_id), &
($assembly.testrig.cis_steering_wheel_joint.object_value.j.adams_id), &
($assembly.ground.origo.adams_id)
elseif condition=($assembly.sse_simulation_type == "ssa")
file text write format="control/routine=abgVDM::con1020, function=user(1020,%d,%G,0,0,%d,%d,1,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.speed), &
($assembly.testrig.cis_steering_wheel_joint.object_value.i.adams_id), &
($assembly.testrig.cis_steering_wheel_joint.object_value.j.adams_id), &
($assembly.ground.origo.adams_id)
file text write format="control/routine=abgVDM::con1021, function=user(1021,%d,%G,%d,%2G,%d,1,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.speed), &
($assembly.sse_brake_flag), &
($assembly.sse_desired_longitudinal_accel), &
($assembly.sse_number_of_steps), &
($assembly.ground.origo.adams_id)
elseif condition=($assembly.sse_simulation_type == "mmm")
file text write format="control/routine=abgVDM::con1020, function=user(1020,%d,%G,0,0,%d,%d,1,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.speed), &
($assembly.testrig.cis_steering_wheel_joint.object_value.i.adams_id), &
($assembly.testrig.cis_steering_wheel_joint.object_value.j.adams_id), &
($assembly.ground.origo.adams_id)
file text write format="motion/%d, function=0.0" &
value=(stoo(get_actuator_instance($assembly,"steering","steering_wheel_angle","jms_*")).motion.adams_id)
file text write format="diff/%d, ic=0.0, function=0.0" &
value=($assembly.testrig.sse_diff2.adams_id)
file text write format="control/routine=abgVDM::con1060, function=user(1060,%d,%2G,%2G,%d,%2G,%2G,%2G,%d,%2G,%d,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), &
($assembly.sse_ini_side_slip_angle), &
($assembly.sse_fin_side_slip_angle), &
($assembly.sse_num_side_slip_steps), &
($assembly.sse_steering_amplitude), &
($assembly.sse_steering_frequency), &
($assembly.sse_simulation_duration), &
($assembly.sse_number_of_steps), &
($assembly.sse_bank_angle), &
(stoo(get_actuator_instance($assembly,"steering","steering_wheel_angle","jms_*")).motion.adams_id), &
($assembly.ground.origo.adams_id)
end
!
!*******************************************************************************
elseif condition=("$simulation_type" == "static_only" || str_match("sdi*", "$simulation_type") || str_match("carat_*", "$simulation_type") || "$simulation_type" == "svc")
!*******************************************************************************
!
if condition=(!anym("output/nosep" == $_self.acf_header))
file text write format="output/nosep"
end
if condition=(db_exists("$assembly.no_initial_velocity"))
variable set variable_name=$_self.no_initial_velocity_id &
integer_value=(eval(-$assembly.no_initial_velocity.adams_id))
else
variable set variable_name=$_self.no_initial_velocity_id &
integer_value=0
end
file text write format="control/routine=abgVDM::EventInit, function=user(%d,%d,%d,%d,%d,%d,%d,%d)" &
value=($assembly.testrig.smart_driver_filename.adams_id), &
($assembly.ground.origo.adams_id), &
($assembly.testrig.initial_conditions_array.adams_id), &
(eval($_self.no_initial_velocity_id)), &
($assembly.testrig.smart_driver_vehicle_parameters_array.adams_id), &
($assembly.testrig.smart_driver_main_array.adams_id), &
($assembly.testrig.ground.iso_eas_mar.adams_id), &
($assembly.testrig.condition_sensor_array.adams_id)
if condition=("$simulation_type" == "static_only")
file text write format="control/routine=abgVDM::EventRunNext, function=user(0)"
elseif condition=("$simulation_type" == "sdi")
file text write format="control/routine=abgVDM::EventRunAll, function=user(0)"
elseif condition=(str_match("sdi_*", "$simulation_type"))
! Static set-up & 1st mini-maneuver
file text write format="control/routine=abgVDM::EventRunNext, function=user(0)"
file text write format="control/routine=abgVDM::EventRunNext, function=user(0)"
if condition=("$simulation_type" == "sdi_brmu")
for variable=$_self.loopobj object=(eval(DB_DEPENDENTS($assembly.testrig.ground.std_tire_ref,"marker")))
file text write format="marker/%d, qp=%f,%f,%f" &
value=($_self.loopobj.object_value.adams_id), &
($assembly.testrig.ground.std_tire_ref.loc_x + 1000000.0), &
($assembly.testrig.ground.std_tire_ref.loc_y), &
($assembly.testrig.ground.std_tire_ref.loc_z)
end
elseif condi=("$simulation_type" == "sdi_sssw")
file text write format="control/routine=abgVDM::val2ary,function=user(%d,1,%d,-1.0)" &
value=(stoo(get_ude_instance($assembly.testrig,"aerodynamic","distance_travelled","ffs_*")).offset_array.adams_id), &
(stoo(get_ude_instance($assembly.testrig,"aerodynamic","distance_travelled","ffs_*")).raw_channel.adams_id)
file text write format="control/routine=abgVDM::val2ary,function=user(%d,2,0,1.0)" &
value=(stoo(get_ude_instance($assembly.testrig,"aerodynamic","distance_travelled","ffs_*")).offset_array.adams_id)
file text write format="control/routine=abgVDM::val2ary,function=user(%d,2,0,1.0)" &
value=($assembly.testrig.wind_velocity.adams_id)
elseif condition=(STR_MATCH("sdi_racl_??", "$simulation_type"))
for variable=$_self.loopobj object=(eval(DB_DEPENDENTS($assembly.testrig.ground.std_tire_ref,"marker")))
if condition=(SUBSYSTEM_LOOKUP($assembly,"wheel",str_substr("$simulation_type",10,1) == "f" ? "front" : "rear") == db_ancestor($_self.loopobj.object_value,"model") && str_typecheck($_self.loopobj.object_value,str_substr("$simulation_type",11,1)))
file text write format="control/routine=abgVDM::val2mar,function=user(%d,1,%d,%f)" &
value=($_self.loopobj.object_value.adams_id), &
(stoo("$assembly.testrig.mea_wheel_distance_"//str_substr("$simulation_type",10,2)).adams_id), &
(STR_MATCH("*_f?","$simulation_type") ? +99000.0 : -99000.0)
end
end
end
! Rest of the mini-maneuvers
file text write format="control/routine=abgVDM::EventRunAll, function=user(0)"
elseif condition=("$simulation_type" == "svc")
file text write format="control/routine=abgVDM::EventRunNext, function=user(0)"
file text write format="control/routine=apresolver::consub, function=user(1111,%d,0,0,0,0,%d,%d)" &
value=($assembly.testrig.sse_ctrl_array1.adams_id), ($assembly.testrig.svc_array_list.adams_id), ($assembly.testrig.svc_array_string.adams_id)
end
!*******************************************************************************
elseif condition=("$simulation_type" == "adrv_svc")
!*******************************************************************************
!
file text write format="simulate/statics"
file text write format="control/routine=apresolver::consub, function=user(1111,-1,0,0,0,0,%d,%d)" &
value=($assembly.testrig.svc_array_list.adams_id), ($assembly.testrig.svc_array_string.adams_id)
!
!*******************************************************************************
elseif condition=("$simulation_type" == "multipost")
!*******************************************************************************
!
if condition=($_self.leafspringFlag != "true")
file text write format="simulate/statics"
end
file text write format="simulate/dynamics, end=$end_time, steps=$number_of_steps"
!
!*******************************************************************************
elseif condition=("$simulation_type" == "multipost_time")
!*******************************************************************************
!
aride fourpost analysis write_acf time_domain &
assembly=$assembly end_time=$end_time number_of_steps=$number_of_steps
!
!*******************************************************************************
elseif condition=("$simulation_type" == "multipost_freq")
!*******************************************************************************
!
aride fourpost analysis write_acf freq_domain &
assembly=$assembly
!
!*******************************************************************************
elseif condition=("$simulation_type" == "quasi_static")
!*******************************************************************************
!
file text write format="simulate/static"
file text write format="simulate/statics, end=$end_time, steps=$number_of_steps"
!
!*******************************************************************************
elseif condition=("$simulation_type" == "sand_bed")
!*******************************************************************************
!
file text write format="output/nosep"
file text write format="simulate/static"
file text write format="simulate/statics, end=$end_time, steps=$number_of_steps"
for var=$_self.t_jprim obj=$assembly.testrig."jolinp_front_wheel_*"
if cond=(db_active($_self.t_jprim)==1)
file text write format="deactivate/jprim,id=%d" value=(eval($_self.t_jprim.id))
end
end
for var=$_self.t_jprim obj=$assembly.testrig."jorinp_front_wheel_*"
if cond=(db_active($_self.t_jprim)==1)
file text write format="deactivate/jprim,id=%d" value=(eval($_self.t_jprim.id))
end
end
for var=$_self.t_jprim obj=$assembly.testrig."jolinp_rear_wheel_*"
if cond=(db_active($_self.t_jprim)==1)
file text write format="deactivate/jprim,id=%d" value=(eval($_self.t_jprim.id))
end
end
for var=$_self.t_jprim obj=$assembly.testrig."jorinp_rear_wheel_*"
if cond=(db_active($_self.t_jprim)==1)
file text write format="deactivate/jprim,id=%d" value=(eval($_self.t_jprim.id))
end
end
if cond=(db_exists("$assembly.JPRIM_x_motion"))
file text write format="deactivate/jprim,id=%d" value=(eval($assembly.JPRIM_x_motion.id))
end
! deactivate pseudo tires (bushings) -->
if cond=(db_exists("$assembly.tir_bush_1"))
file text write format="deactivate/bush,id=%d" value=(eval($assembly.tir_bush_1.id))
end
if cond=(db_exists("$assembly.tir_bush_2"))
file text write format="deactivate/bush,id=%d" value=(eval($assembly.tir_bush_2.id))
end
if cond=(db_exists("$assembly.tir_bush_3"))
file text write format="deactivate/bush,id=%d" value=(eval($assembly.tir_bush_3.id))
end
if cond=(db_exists("$assembly.tir_bush_4"))
file text write format="deactivate/bush,id=%d" value=(eval($assembly.tir_bush_4.id))
end
file text write format="control/routine=abgFDM::con917, function=user(917,%d,0.0,%G,0.0)" &
value=($assembly.ground.origo.adams_id), &
($assembly.testrig.ges_tilt_table.vy)
!
file text write format="simulate/dynamics, end=%s, steps=$number_of_steps" value=(eval($end_time+1.5))
!
!*******************************************************************************
elseif condition=("$simulation_type" == "SPMM")
!*******************************************************************************
variable create variable=$_self.acf_spmm_write &
string=$acf_spmm
for variable=$_self.loopcnt start=1 end=(eval(rows($_self.acf_spmm_write)))
file text write format=(eval($_self.acf_spmm_write[$_self.loopcnt]))
end
!************************************************************
!*******************************************************************************
elseif condition=(str_match("adriveline_*", "$simulation_type"))
!*******************************************************************************
!
adriveline analysis write_acf &
assembly=$assembly &
analysis_name=(eval(.sim_preferences.file_prefix)) &
end_time=$end_time &
number_of_steps=$number_of_steps &
simulation_type=$simulation_type &
leafspringFlag=$_self.leafspringFlag &
error_variable=$error_variable
!
!*******************************************************************************
else
!*******************************************************************************
!
!---- Execute acf create customization macro ----
for variable=$_self.custom_macro object_names=(eval(DB_FILTER_NAME(DB_CHILDREN(0, "macro" ),$_self.name//"_custom_acf")))
if condition=(db_oldest_ancestor($_self.custom_macro.object_value,"library").name == "carat")
acar customize analysis full_vehicle submit acfgen &
assembly=$assembly analysis_name=(eval(.sim_preferences.file_prefix)) simulation_type=$simulation_type end_time=$end_time number_of_steps=$number_of_steps
else
variable set variable=$_self.execCommand integer_value= &
(eval(execute_view_command($_self.custom_macro[1].user_command//" assembly=$assembly analysis_name="//.sim_preferences.file_prefix//" simulation_type=$simulation_type end_time=$end_time number_of_steps=$number_of_steps")))
end
end
end
!
!*******************************************************************************
!*******************************************************************************
!
!---- Write footer information to acf file ----
file text write format="!"
if condition=(getenv("MSC_SHOW_STATUS")=="yes")
!---- Debugging info mostly for testing purposes
file text write format="show status=simulation"
file text write format="!"
end
file text write format="STOP"
file text write format="!"
file text close file=(.sim_preferences.file_prefix//".acf")
!
if condition=("$analysis_mode" != "background")
!
if condition=("$analysis_mode" != "files_only")
acar toolkit message &
message=(eval("Starting analysis #"//RTOI($_self.batchAnalysis[1])//" of vehicle assembly..."))
interface message &
enabled=no
elseif condition=("$analysis_mode" == "graphical")
interface dialog_box undisplay &
dialog_box=.gui.msg_box
end
!
simulation set &
solver_preference=(eval("$analysis_mode" == "graphical" ? "internal" : "external")) &
save_files=yes &
load_analysis=no &
remote_compute=no
!
if condition=(!db_exists(".MDI.plugins.carat"))
simulation set &
show_all_messages=yes
end
!
if condition=("$analysis_mode" == "files_only")
simulation set &
solver_preference=write_files_only
end
!
if condition=(db_exists("$assembly.$'analysis_name'_acf"))
simulation script delete &
sim_script_name=$assembly.$'analysis_name'_acf
end
simulation script read_acf &
sim_script_name=$assembly.$'analysis_name'_acf &
file=(eval(.sim_preferences.file_prefix//".acf"))
!
!############################################################################
!
!---- Check to see if controls is plugged in ...
if condition=(db_exists(".mdi.plugins.controls"))
!
!---- ... and plant_input/outputs exist, and prepare files for controls accordingly
if condition=(allm({db_object_count(db_children($assembly,"PLANT_INPUT")),db_object_count(db_children($assembly,"PLANT_OUTPUT"))} >= 1))
!
variable set variable=HostName int=(eval(run_python_code("import socket, aview_main" // str_chr(10) // "qu='\"'" // str_chr(10)// "name=socket.getfqdn(socket.gethostname())"// str_chr(10) // "cmd='variable set variable_name=ADAMS_Host_Name string='+qu+name+qu"// str_chr(10) // "aview_main.execute_cmd(cmd)")))
!---- Create the .m file for matlab ----
mdi controls controls_plant_export_pio &
model=$assembly &
pinput=(eval(db_children($assembly,"PLANT_INPUT"))) &
poutput=(eval(db_children($assembly,"PLANT_OUTPUT"))) &
user_exec=(eval(str_match("adriveline_*", "$simulation_type")? "adriveline_solver" : "acar_solver")) &
CSD_package=MATLAB &
type=non_linear &
file_prefix=(eval(.sim_preferences.file_prefix)) &
host = (eval(ADAMS_Host_Name)) &
init_stat=no
!
!---- Create the .inf file for Easy5 and MatrixX ----
mdi controls controls_plant_export_pio &
model=$assembly &
pinput=(eval(db_children($assembly,"PLANT_INPUT"))) &
poutput=(eval(db_children($assembly,"PLANT_OUTPUT"))) &
user_exec=(eval(str_match("adriveline_*", "$simulation_type")? "adriveline_solver" : "acar_solver")) &
CSD_package=EASY5_and_MATRIXx &
type=non_linear &
file_prefix=(eval(.sim_preferences.file_prefix)) &
host = (eval(ADAMS_Host_Name)) &
init_stat=no
!
var delete var=ADAMS_Host_Name
var delete var=HostName
!---- write out a special acf file ----
file text open file=(eval(.sim_preferences.file_prefix//"_controls.acf")) open_mode=overwrite
!
for variable=$_self.loopcnt start=3 end=(eval(rows($_self.acf_header)))
file text write format=(eval($_self.acf_header[$_self.loopcnt]))
end
if condition=(!anym("output/nosep" == $_self.acf_header))
file text write format="output/nosep"
end
if condition=(!anym("show status=simulation" == $_self.acf_header))
file text write format="show status=simulation"
end
if condition=(str_match("adriveline_*", "$simulation_type"))
adriveline analysis write_acf &
assembly=$assembly &
analysis_name=(eval(.sim_preferences.file_prefix)) &
end_time=$end_time &
number_of_steps=$number_of_steps &
simulation_type=$simulation_type &
leafspringFlag=$_self.leafspringFlag &
controlsFlag=1 &
error_variable=$error_variable
else
for variable=$_self.loopcnt start=(eval(rows($_self.acf_header)-1)) end=(eval(rows($assembly.$'analysis_name'_acf.commands)))
if condition=(str_match("*EventRun*", $assembly.$'analysis_name'_acf.commands[$_self.loopcnt]))
break
elseif condi=(str_match("*sim*/dyn*", $assembly.$'analysis_name'_acf.commands[$_self.loopcnt]))
break
else
file text write format=(eval($assembly.$'analysis_name'_acf.commands[$_self.loopcnt]))
end
end
end
!
file text write format="show status=simulation"
file text write format="simulate/init"
file text close file=(eval(.sim_preferences.file_prefix//"_controls.acf"))
!
end
end
!
!############################################################################
!
if condition=("$analysis_mode" == "graphical")
simulation single_run set &
update=(eval(.ACAR.variables.graphical_sim_upd)) &
monitor=none &
alert=no &
icon_visibility=off &
save_analyses=no
else
simulation single_run set &
update=none &
monitor=none &
alert=yes &
icon_visibility=off &
save_analyses=no
end
!
!---- CR 53321: checkout AFC, not VFC license
acar toolkit putenv env=MDI_VFC_VISEDIT value=""
interface message threshold=fault
simulation single scripted &
sim_script_name=$assembly.$'analysis_name'_acf &
reset_before_and_after=yes
interface message threshold=warning
acar toolkit putenv env=MDI_VFC_VISEDIT value="yes"
!
interface dialog_box undisplay &
dialog_box=.gui.info_window
interface message &
enabled=yes
else
if condition=(cdb_get_os()=="nt")
!---- Write out bat file for background analysis ----
variable set variable=$_self.fullAnalBat &
string_value=(eval((str_match("./*","$batch_prefix") ? str_delete("$batch_prefix",1,2) : "$batch_prefix")//".bat"))
if condition=($_self.batchAnalysis[1] == 1)
!---- Write bat header ----
file text open file=(eval($_self.fullAnalBat[1])) &
open_mode=overwrite
file text write format="@echo off"
file text write format="echo."
file text write format="set HOME=%s" &
value=(eval( GETENV("HOME") ))
file text write format="set MDI_ACAR_SITE=%s" &
value=(eval( GETENV("MDI_ACAR_SITE") ))
file text write format="echo \'Performing full vehicle analyses...\'"
file text write format="echo."
file text write format="rem Run Adams on all driver loadcases:"
file text close file=(eval($_self.fullAnalBat[1]))
end
!---- Write information to bat script ----
file text open file=(eval($_self.fullAnalBat[1])) &
open_mode=append
file text write format="rem Loadcase Run #%d" &
values=(eval($_self.batchAnalysis[1]))
! file text write format="clear;echo;echo"
file text write format="echo \'Performing full vehicle analysis #%d...\'" &
values=(eval($_self.batchAnalysis[1]))
file text write format="echo."
file text write format="call %scommon\\\\mdi.bat acar ru-solver %s" &
values=(eval(getenv("short_topdir"))), &
(eval(.sim_preferences.file_prefix//".acf"))
file text write format="if exist %s.bat call %s.bat" &
values=(eval(.sim_preferences.file_prefix)),(eval(.sim_preferences.file_prefix))
file text close file=(eval($_self.fullAnalBat[1]))
else
!---- Write out c-shell for background analysis ----
variable set variable=$_self.fullAnalCsh &
string_value=(eval("$batch_prefix"//".csh"))
if condition=($_self.batchAnalysis[1] == 1)
!---- Write csh header ----
file text open file=(eval($_self.fullAnalCsh[1])) &
open_mode=overwrite
file text write format="#! /bin/csh -f"
file text write format=""
file text write format="echo;echo"
file text write format="echo \'Performing full vehicle analyses...\'"
file text write format="echo;sleep 3"
if condition=(getenv("LD_LIBRARY_SAVE")!="")
file text write format="setenv LD_LIBRARY_PATH %s" &
value=(eval( GETENV("LD_LIBRARY_SAVE") ))
else
file text write format="unsetenv LD_LIBRARY_PATH"
end
file text write format=""
file text write format="#Run Adams on all driver loadcases:"
file text close file=(eval($_self.fullAnalCsh[1]))
end
!---- Write information to csh script ----
file text open file=(eval($_self.fullAnalCsh[1])) &
open_mode=append
file text write format="#"
file text write format="# Loadcase Run #%d" &
values=(eval($_self.batchAnalysis[1]))
file text write format="clear;echo;echo"
file text write format="echo \'Performing full vehicle analysis #%d...\'" &
values=(eval($_self.batchAnalysis[1]))
file text write format="echo;sleep 3"
file text write format="%smdi -c acar ru-solver i %s exit" &
values=(eval(getenv("topdir"))), &
(eval(.sim_preferences.file_prefix//".acf"))
file text write format="sleep 3"
file text write format="if ( -f %s.csh && -x %s.csh ) ./%s.csh" &
values=(eval(.sim_preferences.file_prefix)),(eval(.sim_preferences.file_prefix)),(eval(.sim_preferences.file_prefix))
file text close file=(eval($_self.fullAnalCsh[1]))
end
end
!
if condition=("$analysis_mode" == "background" && $_self.batchAnalysis[1] == $_self.batchAnalysis[2])
if condition=(cdb_get_os()=="nt")
!---- Write footer to bat script ----
file text open file=(eval($_self.fullAnalBat[1])) &
open_mode=append
file text write format="rem Clean-up after itself"
file text write format="del %s & exit" &
values=(eval(cdb_unix2nt_path($_self.fullAnalBat[1])))
file text close file=(eval($_self.fullAnalBat[1]))
!---- Execute the analysis in the background ----
acar toolkit message &
message="Starting background analyses of vehicle assembly..."
if condition=(db_exists(".ACAR.variables.WinCMDOptions"))
variable set variable=$_self.tmpstr string=(eval(.ACAR.variables.WinCMDOptions))
else
variable set variable=$_self.tmpstr string=(eval(getenv("ACAR_TESTING") == "" ? "" : "/b /min /separate /high /wait"))
end
system command=(eval("start \"Adams Car Full Vehicle Analysis\" "//$_self.tmpstr//" "//$_self.fullAnalBat[1])) &
echo=off send=off
else
!---- Write footer to csh script ----
file text open file=(eval($_self.fullAnalCsh[1])) &
open_mode=append
file text write format="#"
file text write format="# Clean-up after itself"
file text write format="/bin/rm %s" &
values=(eval($_self.fullAnalCsh[1]))
file text close file=(eval($_self.fullAnalCsh[1]))
!---- Execute the analysis in the background ----
system command=(eval("/bin/chmod u+x "//$_self.fullAnalCsh[1])) &
echo=off send=off
acar toolkit message &
message="Starting background analyses of vehicle assembly..."
system command=(eval("xterm -title \'Adams Car Full Vehicle Analysis\' -n \'A/Car Analysis\' -fg green -bg black -fn 9x15 -g 80x25-0+0 -e "//$_self.fullAnalCsh[1]//(getenv("ACAR_TESTING") == "" ? "\&" : ""))) &
echo=off send=off
end
end
!
!---- Read in the results upon request ----
if condition=($load_results && allm("$analysis_mode" != {"background","files_only"}))
!
acar postprocessing analysis read &
assembled_model=$assembly &
analysis_name=(eval(.sim_preferences.file_prefix//".req")) &
read_requests=(eval($assembly.analysis_flags.output_reqsave ? "yes" : "no")) &
read_graphics=(eval($assembly.analysis_flags.output_grsave ? "yes" : "no")) &
read_results=(eval($assembly.analysis_flags.results_flag ? "yes" : "no")) &
error_variable=$error_variable
!
if condition=(db_exists("$assembly."//.sim_preferences.file_prefix))
!
!---- Generate the road geometry ----
if condition=($generate_road_geometry && $_self.smartRoad == 1 && "$analysis_mode" == "interactive" && !$_self.aiRun)
!
if condition=($_self.rcdCnt == 0)
variable set variable=$_self.ignoreMe integer=0
acar toolkit road generate_geometry &
road_data_file="$road_data_file" &
road_reference_marker=$assembly.testrig.ground.std_tire_ref &
assembly=$assembly &
superimpose=no & ! already purged path lines above
error_variable=$_self.ignoreMe ! we know road file exists - don't want to screw the errorFlag
!--- Remove the actual driver path when updating the road graphics
if condition=(rows(db_filter_name(db_children($assembly.testrig.ground,"bspline"),"GCURVE_*")) > 0)
geometry delete geometry_name = (eval(db_children($assembly.testrig.ground,"bspline")))
end
end
!
!---- Associate road file with analysis ----
if condition=(!$error_variable) ! analysis does not exist or is from previous run
if condition=(db_exists("$assembly."//.sim_preferences.file_prefix//".road_filename_memory"))
entity delete entity=("$assembly."//.sim_preferences.file_prefix//".road_filename_memory")
end
if condition=(db_exists("$assembly.road_filename"))
entity copy entity=$assembly.road_filename &
new_entity=(eval("$assembly."//.sim_preferences.file_prefix//".road_filename_memory"))
end
if condition=(db_exists("$assembly.road_filedata"))
entity copy entity=$assembly.road_filedata &
new_entity=(eval("$assembly."//.sim_preferences.file_prefix//".road_filedata_memory"))
end
end
end
end
if condition=(!ANYM(SIM_STATUS("$'analysis_name'.msg")) && !ANYM(TERM_STATUS("$'analysis_name'.msg")))
acar analysis alignment set motion_lock &
assembly=$assembly &
error_variable=$error_variable
end
end
!
if condition=("$analysis_mode" == "files_only" && file_exists(.sim_preferences.file_prefix//".adm"))
acar toolkit message &
message="Adams Solver files written successfully."
end
!---- Reset contacts and clearances that reference the road ----
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_contact_definition")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime")
variable set variable=($_self.loopobj.object_value.j_contact_body) &
object=(eval($_self.loopobj.object_value.parent//".ground._cv_csolid"))
end
acar standard_interface instance ac_contact_definition repair instance_name=($_self.loopobj.object_value)
end
for variable=$_self.loopobj object=(eval(db_children("$assembly","ac_runtime_clearance")))
if condition=(db_active($_self.loopobj.object_value) && $_self.loopobj.object_value.connect_type.string_value == "runtime")
variable set variable=($_self.loopobj.object_value.j_contact_body) &
object=(eval($_self.loopobj.object_value.parent//".ground._cv_csolid"))
end
acar standard_interface instance ac_runtime_clearance repair instance_name=($_self.loopobj.object_value)
end
!
!---- Activate IC_couplers we turned off earlier ----
if condition=(db_exists("$_self.IC_couplers"))
entity attributes &
entity_name=(eval($_self.IC_couplers.object_value)) &
active=no_opinion
end
if condition=(db_exists("$assembly.IC_setup"))
entity attributes &
entity_name=$assembly.IC_setup &
active=no_opinion
end
!
!---- Execute post-analysis customization macro ----
for variable=$_self.custom_macro object_names=(eval(DB_FILTER_NAME(DB_CHILDREN(0, "macro" ),$_self.name//"_custom_pos")))
if condition=(db_oldest_ancestor($_self.custom_macro.object_value,"library").name == "carat")
acar customize analysis full_vehicle submit pospro &
assembly=$assembly analysis_mode=$analysis_mode analysis_name=(eval(.sim_preferences.file_prefix)) simulation_type=$simulation_type
else
variable set variable=$_self.execCommand integer_value= &
(eval(execute_view_command($_self.custom_macro[1].user_command//" assembly=$assembly analysis_mode=$analysis_mode analysis_name="//.sim_preferences.file_prefix//" simulation_type=$simulation_type")))
end
end
!
variable delete variable_name=(eval(db_children($_self,"variable")))
if condition=("$caller" == "other")
interface model_browser set auto_refresh=on refresh_now=yes
end
